#include "atomic_block.hpp"
#include "cut.hpp"


int main(int argc, char *argv[])
{
    mockturtle::aig_network aig;
    lorina::read_aiger("file.aig", mockturtle::aiger_reader(aig));
    std::vector<Cutt*> cs = Cutt::ExtractCuts(aig, 3u, 100u);
    std::pair<std::vector<Atomic>, std::vector<Atomic>> hf = Atomic::identifyHAsFAs(cs);
    Atomic::removeHAsInFAs(hf);
    Atomic::removeAtomicsWithIntersection(hf.first);
    std::cout<<"Half-Adders: "<<std::endl;
    for (auto i: hf.first)
        std::cout<<i<<std::endl;
    std::cout<<"Full-Adders: "<<std::endl;
    for (auto i: hf.second)
        std::cout<<i<<std::endl;
        
}   
